;********************************************************
;*vO	pwm_m168_lcd1
;*CPU			ATMEGA168g[jO{[h(mega_8_v1)
;*NbN		8MHz
;*쐬		2010/07/16
; LCD L1634(16x2s)ɑΉ
;********************************************************

.include "m168def.inc"

.equ 			pwm_cunt=0x100
.equ 			pwm_low=0x101
.equ			pwm_data=0x102
.equ			enc_data=0x103
.equ			inp_data=0x104
.equ			sw_data=0x105
.equ			momax_d=0x106
.equ			rcunt=0x107
.equ			DIGIT_cunt0=0x108
.equ			DIGIT_cunt1=0x109
.equ			data_bin0=0x10a				;binaryf[^
.equ			data_bin1=0x10b
.equ			bcd_d0=0x10c				;bcdf[^
.equ			bcd_d1=0x10d
.equ			bcd_d2=0x10e
.equ			bcd_d3=0x10f

;---------------------------------------------------
;PB0-[E-6]    PB1-[RS-4]   PB2-[R/W-5]  PB3-[ ] 
;PB4-[DB4-11] PB5-[DB5-12] PB6-[DB6-13] PB7-[DB7-14]   
;--------------------------------------------------
;--------t\p
.equ			lcd_data_10=bcd_d3+1			;1s0
.equ			lcd_data_11=lcd_data_10+1
.equ			lcd_data_12=lcd_data_11+1
.equ			lcd_data_13=lcd_data_12+1
.equ			lcd_data_14=lcd_data_13+1
.equ			lcd_data_15=lcd_data_14+1
.equ			lcd_data_16=lcd_data_15+1
.equ			lcd_data_17=lcd_data_16+1
.equ			lcd_data_18=lcd_data_17+1
.equ			lcd_data_19=lcd_data_18+1
.equ			lcd_data_1a=lcd_data_19+1
.equ			lcd_data_1b=lcd_data_1a+1
.equ			lcd_data_1c=lcd_data_1b+1
.equ			lcd_data_1d=lcd_data_1c+1
.equ			lcd_data_1e=lcd_data_1d+1
.equ			lcd_data_1f=lcd_data_1e+1
.equ			lcd_data_20=lcd_data_1f+1		;2s0
.equ			lcd_data_21=lcd_data_20+1
.equ			lcd_data_22=lcd_data_21+1
.equ			lcd_data_23=lcd_data_22+1
.equ			lcd_data_24=lcd_data_23+1
.equ			lcd_data_25=lcd_data_24+1
.equ			lcd_data_26=lcd_data_25+1
.equ			lcd_data_27=lcd_data_26+1
.equ			lcd_data_28=lcd_data_27+1
.equ			lcd_data_29=lcd_data_28+1
.equ			lcd_data_2a=lcd_data_29+1
.equ			lcd_data_2b=lcd_data_2a+1
.equ			lcd_data_2c=lcd_data_2b+1
.equ			lcd_data_2d=lcd_data_2c+1
.equ			lcd_data_2e=lcd_data_2d+1
.equ			lcd_data_2f=lcd_data_2e+1
.equ			lcd_data_30=lcd_data_2f+1		;3s0
.equ			lcd_data_31=lcd_data_30+1
.equ			lcd_data_32=lcd_data_31+1
.equ			lcd_data_33=lcd_data_32+1
.equ			lcd_data_34=lcd_data_33+1
.equ			lcd_data_35=lcd_data_34+1
.equ			lcd_data_36=lcd_data_35+1
.equ			lcd_data_37=lcd_data_36+1
.equ			lcd_data_38=lcd_data_37+1
.equ			lcd_data_39=lcd_data_38+1
.equ			lcd_data_3a=lcd_data_39+1
.equ			lcd_data_3b=lcd_data_3a+1
.equ			lcd_data_3c=lcd_data_3b+1
.equ			lcd_data_3d=lcd_data_3c+1
.equ			lcd_data_3e=lcd_data_3d+1
.equ			lcd_data_3f=lcd_data_3e+1

.equ			lcd_data_40=lcd_data_3f+1		;2s0
.equ			lcd_data_41=lcd_data_40+1
.equ			lcd_data_42=lcd_data_41+1
.equ			lcd_data_43=lcd_data_42+1
.equ			lcd_data_44=lcd_data_43+1
.equ			lcd_data_45=lcd_data_44+1
.equ			lcd_data_46=lcd_data_45+1
.equ			lcd_data_47=lcd_data_46+1
.equ			lcd_data_48=lcd_data_47+1
.equ			lcd_data_49=lcd_data_48+1
.equ			lcd_data_4a=lcd_data_49+1
.equ			lcd_data_4b=lcd_data_4a+1
.equ			lcd_data_4c=lcd_data_4b+1
.equ			lcd_data_4d=lcd_data_4c+1
.equ			lcd_data_4e=lcd_data_4d+1
.equ			lcd_data_4f=lcd_data_4e+1
.equ			lcdset_data=lcd_data_4f+1
.equ			lcdad_data=lcdset_data+1

			
.org	0x00		jmp	reset				;e탊Zbg
;.org	0x02		jmp	ext_int0			;Oriݗv0
;.org	0x04		jmp ext_int1			;O荞ݗv1
;.org	0x06		jmp pcint_0				;sω荞ݗv0
;.org	0x08		jmp pcint_1				;sω荞ݗv1
.org	0x0a		jmp pcint_2				;sω荞ݗv2
;.org	0x0c		jmp wdt_ovf				;EHb`hHbOv
;.org	0x0e		jmp tim2_compa			;^C}/JE^2rAv
;.org	0x10		jmp tim2_compb			;^C}/JE^2rBv
;.org	0x12		jmp tim2_ovf			;^C}/JE^2I[o[t[
;.org	0x14		jmp tim1_capt			;^C}/JE^1ߊl(Lv`)
;.org	0x16		jmp tim1_compa			;^C}/JE^1rAv
;.org	0x18		jmp tim1_compb			;^C}/JE^1rBv
.org	0x1a		jmp tim1_ovf			;^C}/JE^1I[o[t[ 
;.org	0x1c		jmp tim0_compa			;^C}/JE^0rAv
;.org	0x1e		jmp tim0_compb			;^C}/JE^0rBv
.org	0x20		jmp tim0_ovf			;^C}/JE^0I[o[t[
;.org	0x22		jmp spi_stc				;spi]
;.org	0x24		jmp usart_rxc			;usart M
;.org	0x26		jmp usart_udre			;usart Mobt@
;.org	0x28		jmp usart_txc			;usart M
;.org	0x2a		jmp adc_i				;adcϊ
;.org	0x2c		jmp ee_rdy				;eeprom
;.org	0x2e		jmp ana_comp			;AiOro͑J
;.org	0x30		jmp twi					;2VAC^[tF[Xԕω
;.org	0x32		jmp spm_rdy				;spmߑ

tim1_ovf:			push r16
					in r16,sreg
					push r16
					push r17
					lds r16,pwm_cunt
					inc r16
					sts pwm_cunt,r16
					cpi r16,250;60
					brcs pwm_s
					ldi r16,1
					sts pwm_cunt,r16
pwm_s:				lds r17,pwm_data
					cp	r16,r17
					brcs tim1p
					ldi r16,0x00
					rjmp tim1n
tim1p:				ldi r16,0x04
tim1n:				in r17,portc
					andi r17,0x03
					or r16,r17	
					out portc,r16							
					ldi r16,'['
					sts lcd_data_10,r16
					lds r16,pwm_data
					dec r16
					sts data_bin0,r16
					ldi r16,0
					sts data_bin1,r16
					call bin2bcd	
					lds r16,bcd_d2
					ori r16,0x30
					sts lcd_data_11,r16
					lds r16,bcd_d1	
					ori r16,0x30	
					sts lcd_data_12,r16
					lds r16,bcd_d0
					ori r16,0x30
					sts lcd_data_13,r16
					ldi r16,']'
					sts lcd_data_14,r16
					ldi r16,0xff
					sts tcnt1h,r16
					ldi r16,0xd0
					sts tcnt1l,r16
					pop r17
					pop r16
					out sreg,r16
					pop r16
					reti
;-----------------------------------------------
;^C}0荞
;
tim0_ovf:			push r16
					in r16,sreg
					push r16
					push r17
					rcall sw_pind;lcd_out 
					ldi r16,'2'
					sts lcd_data_15,r16
					ldi r16,'4'
					sts lcd_data_16,r16
					ldi r16,'4'
					sts lcd_data_17,r16
					ldi r16,0xff
					out tcnt0,r16
					pop r17
					pop r16
					out sreg,r16
					pop r16
					reti
;--------------------------------------------------
pcint_2:			push r16
					in r16,sreg	
					push r16
					push r17
					ldi r16,' '
					sts lcd_data_18,r16
					ldi r16,'['
					sts lcd_data_19,r16
					ldi r16,']'
					sts lcd_data_1e,r16
					in r16,pind
					andi r16,0x07
					cpi r16,0x06
					brne sw1_stop
					in r17,portc
					andi r17,0xfc
					ori r17,0x02	
					out portc,r17
					ldi r16,' '
					sts lcd_data_1a,r16
					ldi r16,' '
					sts lcd_data_1b,r16
					ldi r16,'C'
					sts lcd_data_1c,r16
					ldi r16,'W'
					sts lcd_data_1d,r16
					rjmp pc1_a
sw1_stop:			cpi r16,0x05
					brne sw2_ccw
					in r17,portc
					andi r17,0xfc
					ori r17,0x03
					out portc,r17
					ldi r16,'S'
					sts lcd_data_1a,r16
					ldi r16,'T'
					sts lcd_data_1b,r16
					ldi r16,'O'
					sts lcd_data_1c,r16
					ldi r16,'P'
					sts lcd_data_1d,r16
					rjmp pc1_a
sw2_ccw:			cpi r16,0x03
					brne pc1_a
					in r17,portc
					andi r17,0xfc
					ori r17,0x01
					out portc,r17
					ldi r16,' '
					sts lcd_data_1a,r16				
					ldi r16,'C'
					sts lcd_data_1b,r16				
					ldi r16,'C'
					sts lcd_data_1c,r16				
					ldi r16,'W'
					sts lcd_data_1d,r16
pc1_a:				in r16,pind
					com r16
					andi r16,0xe0
					cpi r16,0x20
					brne pcin_1a
					ldi r16,245
					sts pwm_data,r16
					rjmp pcint2_end
pcin_1a:			cpi r16,0x40
					brne pcin_2a
					ldi r16,122
					sts pwm_data,r16
					rjmp pcint2_end
pcin_2a:			cpi r16,0x80
					brne pcint2_end
					ldi r16,1
					sts pwm_data,r16
pcint2_end:			pop r17
					pop r16
					out sreg,r16
					pop r16				
					reti
;--------------------------------------------------
;Zbg
;
reset:				ldi r16,low(ramend)
					out	spl,r16
					ldi r16,high(ramend)
					out sph,r16
					ldi r16,0x03
					sts tccr1b,r16
					ldi r16,0xfe
					sts tcnt1h,r16
					sts tcnt1l,r16
					ldi r16,0x01
					sts	timsk1,r16
					ldi r16,0x01
					out tccr0b,r16
					ldi r16,0xff
					out tcnt0,r16
					ldi r16,0x01 
					sts timsk0,r16
					ldi r16,0xff
					out ddrb,r16
					ldi r16,0xff
					out ddrc,r16
					ldi	r16,0x00//
					out ddrd,r16
					ldi r16,0xe7
					sts pcmsk2,r16
					ldi r16,0x04
					sts pcicr,r16
					ldi	r16,0x00
					sts enc_data,r16
					sts inp_data,r16
					sts pwm_cunt,r16
					ldi r16,10;4
					sts pwm_cunt,r16
					ldi r16,1
					sts pwm_data,r16
					rcall lcdini
					rcall lcd_test1
					rcall lcd_out 
					ldi r16,50
m_syoki1:			dec r16
					cpi r16,0
					breq m_syoki
					rcall tim10ms
					rcall tim10ms
					rcall tim10ms
					rcall tim10ms
					rjmp m_syoki1
m_syoki:			rcall lcd_cls
					rcall lcd_syoki
					rcall lcd_data_ini1
					rcall lcd_data_ini2
					rcall lcd_data_msg1
					sei
main:				rcall lcd_out 
					rjmp main

lcd_data_ini1:
					ldi r16,'P'
					sts lcd_data_20,r16
					ldi r16,'D'
					sts lcd_data_21,r16
					ldi r16,'0'
					sts lcd_data_22,r16
					ldi r16,':'
					sts lcd_data_23,r16
					ldi r16,'C'
					sts lcd_data_24,r16
					ldi r16,'W'
					sts lcd_data_25,r16
					ldi r16,'P'
					sts lcd_data_27,r16
					ldi r16,'D'
					sts lcd_data_28,r16
					ldi r16,'1'
					sts lcd_data_29,r16
					ldi r16,':'
					sts lcd_data_2a,r16
					ldi r16,'S'
					sts lcd_data_2b,r16
					ldi r16,'T'
					sts lcd_data_2c,r16
					ldi r16,'O'
					sts lcd_data_2d,r16
					ldi r16,'P'
					sts lcd_data_2e,r16
					ret

lcd_data_ini2:		ldi r16,'P'
					sts lcd_data_30,r16
					ldi r16,'D'
					sts lcd_data_31,r16
					ldi r16,'2'
					sts lcd_data_32,r16
					ldi r16,':'
					sts lcd_data_33,r16
					ldi r16,'C'
					sts lcd_data_34,r16
					ldi r16,'C'
					sts lcd_data_35,r16
					ldi r16,'W'
					sts lcd_data_36,r16
					ret

lcd_data_msg1:
					ldi r16,'['
					sts lcd_data_40,r16
					ldi r16,''
					sts lcd_data_41,r16
					ldi r16,''
					sts lcd_data_42,r16
					ldi r16,''
					sts lcd_data_43,r16
					ldi r16,''
					sts lcd_data_44,r16
					ldi r16,''
					sts lcd_data_45,r16
					ldi r16,''
					sts lcd_data_46,r16
					ldi r16,''
					sts lcd_data_47,r16
					ldi r16,''
					sts lcd_data_48,r16
					ldi r16,''
					sts lcd_data_49,r16
					ldi r16,''
					sts lcd_data_4a,r16
					ldi r16,']'
					sts lcd_data_4b,r16
					ldi r16,' '
					sts lcd_data_4c,r16
					ldi r16,''
					sts lcd_data_4d,r16
					ldi r16,''
					sts lcd_data_4e,r16
					ldi r16,''
					sts lcd_data_4f,r16
					ret

lcd_syoki:			ldi r16,'['
					sts lcd_data_10,r16
					ldi r16,'0'
					sts lcd_data_11,r16
					ldi r16,'0'
					sts lcd_data_12,r16
					ldi r16,'0'
					sts lcd_data_13,r16
					ldi r16,']'
					sts lcd_data_14,r16
					ldi r16,'2'
					sts lcd_data_15,r16
					ldi r16,'4'
					sts lcd_data_16,r16
					ldi r16,'4'
					sts lcd_data_17,r16
					ldi r16,' '
					sts lcd_data_18,r16
					ldi r16,'['
					sts lcd_data_19,r16
					ldi r16,'S'
					sts lcd_data_1a,r16
					ldi r16,'T'
					sts lcd_data_1b,r16
					ldi r16,'O'
					sts lcd_data_1c,r16
					ldi r16,'P'
					sts lcd_data_1d,r16
					ldi r16,']'
					sts lcd_data_1e,r16
					ldi r16,' '
					sts lcd_data_1f,r16
					ret
sw_pind:			in r16,pind
					andi r16,0x18
					lds r17,inp_data
					cp r16,r17
					breq sw_pinde
					sts inp_data,r16
sw_pind_1:			rcall tim1ms					
					in r16,pind
					andi r16,0x18
					lsr r16
					lsr r16
					lsr r16
					lds r17,enc_data
					lsl r17
					lsl r17
					or r17,r16
					sts enc_data,r17
					cpi r17,0x87
					breq pudata
					cpi r17,0xd2
					breq maidata
					rjmp sw_pinde;main
pudata:				lds r16,pwm_data
					inc r16	
					sts pwm_data,r16
					cpi r16,244;41
					brcs sw_pinde;mainend
					ldi r16,245;55
					sts pwm_data,r16
					rjmp sw_pinde;mainend
maidata:			lds r16,pwm_data
					dec r16
endsts:				sts pwm_data,r16
					cpi r16,0x2
					brcc sw_pinde;mainend
					ldi r16,0x01
					sts pwm_data,r16
sw_pinde:			ret

;----------------------------------------
;tgfobNp
;---------------------------------
;lcd_data0`15ɕi[
;
lcd_test1:
					rcall lcd_cls
					ldi r16,'W'
					sts lcd_data_10,r16
					ldi r16,'e'
					sts lcd_data_11,r16
					ldi r16,'l'
					sts lcd_data_12,r16
					ldi r16,'l'
					sts lcd_data_13,r16
					ldi r16,'c'
					sts lcd_data_14,r16
					ldi r16,'o'
					sts lcd_data_15,r16
					ldi r16,'m'
					sts lcd_data_16,r16
					ldi r16,'e'
					sts lcd_data_17,r16
					ldi r16,'D'
					sts lcd_data_18,r16
					ldi r16,'I'
					sts lcd_data_19,r16
					ldi r16,'G'
					sts lcd_data_1a,r16				
					ldi r16,'I'
					sts lcd_data_1b,r16				
					ldi r16,'T'
					sts lcd_data_1c,r16					
					ldi r16,' '
					sts lcd_data_1d,r16					
					ldi r16,'1'
					sts lcd_data_1e,r16
					ldi r16,' '
					sts lcd_data_1f,r16	
					ldi r16,'H'
					sts lcd_data_20,r16
					ldi r16,'e'
					sts lcd_data_21,r16
					ldi r16,'l'
					sts lcd_data_22,r16
					ldi r16,'l'
					sts lcd_data_23,r16
					ldi r16,'o'
					sts lcd_data_24,r16
					ldi r16,' '
					sts lcd_data_25,r16
					ldi r16,'W'
					sts lcd_data_26,r16
					ldi r16,'o'
					sts lcd_data_27,r16
					ldi r16,'r'
					sts lcd_data_28,r16
					ldi r16,'l'
					sts lcd_data_29,r16
					ldi r16,'d'
					sts lcd_data_2a,r16				
					ldi r16,'!'
					sts lcd_data_2b,r16				
					ldi r16,'!'
					sts lcd_data_2c,r16					
					ldi r16,' '
					sts lcd_data_2d,r16					
					ldi r16,' '
					sts lcd_data_2e,r16
					ldi r16,' '
					sts lcd_data_2f,r16	

ldi r16,'E'
					sts lcd_data_30,r16
					ldi r16,'r'
					sts lcd_data_31,r16
					ldi r16,'r'
					sts lcd_data_32,r16
					ldi r16,'a'
					sts lcd_data_33,r16
					ldi r16,'r'
					sts lcd_data_34,r16
					ldi r16,'e'
					sts lcd_data_35,r16
					ldi r16,' '
					sts lcd_data_36,r16
					ldi r16,'e'
					sts lcd_data_37,r16
					ldi r16,'s'
					sts lcd_data_38,r16
					ldi r16,'t'
					sts lcd_data_39,r16
					ldi r16,' '
					sts lcd_data_3a,r16				
					ldi r16,'h'
					sts lcd_data_3b,r16				
					ldi r16,'u'
					sts lcd_data_3c,r16					
					ldi r16,'m'
					sts lcd_data_3d,r16					
					ldi r16,'a'
					sts lcd_data_3e,r16
					ldi r16,'n'
					sts lcd_data_3f,r16	
					ldi r16,'u'
					sts lcd_data_40,r16
					ldi r16,'m'
					sts lcd_data_41,r16
					ldi r16,' '
					sts lcd_data_42,r16
					ldi r16,'H'
					sts lcd_data_43,r16
					ldi r16,'y'
					sts lcd_data_44,r16
					ldi r16,'e'
					sts lcd_data_45,r16
					ldi r16,'r'
					sts lcd_data_46,r16
					ldi r16,'o'
					sts lcd_data_47,r16
					ldi r16,'n'
					sts lcd_data_48,r16
					ldi r16,'y'
					sts lcd_data_49,r16
					ldi r16,'m'
					sts lcd_data_4a,r16				
					ldi r16,'o'
					sts lcd_data_4b,r16				
					ldi r16,'s'
					sts lcd_data_4c,r16					
					ldi r16,' '
					sts lcd_data_4d,r16					
					ldi r16,' '
					sts lcd_data_4e,r16
					ldi r16,' '
					sts lcd_data_4f,r16
					ret
;-------------------------------------------
;lcd_data
lcd_cls:			ldi r16,0x10
					sts lcd_data_10,r16
					sts lcd_data_11,r16
					sts lcd_data_12,r16
					sts lcd_data_13,r16
					sts lcd_data_14,r16
					sts lcd_data_15,r16
					sts lcd_data_16,r16
					sts lcd_data_17,r16
					sts lcd_data_18,r16
					sts lcd_data_19,r16
					sts lcd_data_1a,r16
					sts lcd_data_1b,r16
					sts lcd_data_1c,r16
					sts lcd_data_1d,r16
					sts lcd_data_1e,r16
					sts lcd_data_1f,r16	
					sts lcd_data_20,r16
					sts lcd_data_21,r16
					sts lcd_data_22,r16
					sts lcd_data_23,r16
					sts lcd_data_24,r16
					sts lcd_data_25,r16
					sts lcd_data_26,r16
					sts lcd_data_27,r16
					sts lcd_data_28,r16
					sts lcd_data_29,r16
					sts lcd_data_2a,r16
					sts lcd_data_2b,r16
					sts lcd_data_2c,r16
					sts lcd_data_2d,r16
					sts lcd_data_2e,r16
					sts lcd_data_2f,r16	
					
					sts lcd_data_30,r16
					sts lcd_data_31,r16
					sts lcd_data_32,r16
					sts lcd_data_33,r16
					sts lcd_data_34,r16
					sts lcd_data_35,r16
					sts lcd_data_36,r16
					sts lcd_data_37,r16
					sts lcd_data_38,r16
					sts lcd_data_39,r16
					sts lcd_data_3a,r16
					sts lcd_data_3b,r16
					sts lcd_data_3c,r16
					sts lcd_data_3d,r16
					sts lcd_data_3e,r16
					sts lcd_data_3f,r16	
					sts lcd_data_40,r16
					sts lcd_data_41,r16
					sts lcd_data_42,r16
					sts lcd_data_43,r16
					sts lcd_data_44,r16
					sts lcd_data_45,r16
					sts lcd_data_46,r16
					sts lcd_data_47,r16
					sts lcd_data_48,r16
					sts lcd_data_49,r16
					sts lcd_data_4a,r16
					sts lcd_data_4b,r16
					sts lcd_data_4c,r16
					sts lcd_data_4d,r16
					sts lcd_data_4e,r16
					sts lcd_data_4f,r16								
					ret
;--------------------------------------
lcd_out:			push r16
					in r16,sreg
					push r16
					rcall lcdhed1_set			;t1sڐ擪AhXZbg
					lds r16,lcd_data_10
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_11
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_12
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_13
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_14
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_15
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_16
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_17
					sts lcdset_data,r16
					rcall lcd_set
				;	rcall lcdhed2_set			;2s
					lds r16,lcd_data_18
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_19
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_1a
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_1b
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_1c
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_1d
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_1e
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_1f
					sts lcdset_data,r16
					rcall lcd_set

					rcall lcdhed2_set			;2s
					lds r16,lcd_data_20
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_21
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_22
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_23
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_24
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_25
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_26
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_27
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_28
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_29
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_2a
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_2b
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_2c
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_2d
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_2e
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_2f
					sts lcdset_data,r16
					rcall lcd_set

					rcall lcdhed3_set			;t3sڐ擪AhXZbg
					lds r16,lcd_data_30
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_31
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_32
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_33
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_34
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_35
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_36
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_37
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_38
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_39
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_3a
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_3b
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_3c
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_3d
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_3e
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_3f
					sts lcdset_data,r16
					rcall lcd_set

					rcall lcdhed4_set			;4s
					lds r16,lcd_data_40
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_41
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_42
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_43
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_44
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_45
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_46
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_47
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_48
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_49
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_4a
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_4b
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_4c
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_4d
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_4e
					sts lcdset_data,r16
					rcall lcd_set
					lds r16,lcd_data_4f
					sts lcdset_data,r16
					rcall lcd_set


lcdoutend:			pop r16
					out sreg,r16
					pop r16
					ret
;--------------------------------------
;z[|WV
;
home_p:				push r16
					in r16,sreg
					push r16
					ldi r16,0x01
					out portb,r16
					cbi portb,0
					sbi portb,0
					ldi r16,0x21
					out portb,r16
					cbi portb,0
					sbi portb,0
					rcall tim1ms
					rcall tim1ms
					pop r16
					out sreg,r16
					pop r16
					ret
;--------------------------------------	
;4sڂ̓o
;
lcdhed4_set:		push r16
					in r16,sreg
					push r16
					ldi r16,0x50 ;40
					sts lcdad_data,r16
					rcall lcdad_set
					pop r16
					out sreg,r16
					pop r16					
					ret
;-------------------------------------
;--------------------------------------	
;3sڂ̓o
;
lcdhed3_set:		push r16
					in r16,sreg
					push r16
					ldi r16,0x10
					sts lcdad_data,r16
					rcall lcdad_set
					pop r16
					out sreg,r16
					pop r16					
					ret
;--------------------------------------	
;2sڂ̓o
;
lcdhed2_set:		push r16
					in r16,sreg
					push r16
					ldi r16,0x40
					sts lcdad_data,r16
					rcall lcdad_set
					pop r16
					out sreg,r16
					pop r16					
					ret
;----------------------------------------
;1sړo
;
lcdhed1_set:		push r16
					in r16,sreg
					push r16
					ldi r16,0x00
					sts lcdad_data,r16
					rcall lcdad_set
					pop r16
					out sreg,r16
					pop r16					
					ret
;----------------------------------------
;lcdad_data->
;DDRAMAhXZbg
;
lcdad_set:			push r16
					in r16,sreg
					push r16

					lds r16,lcdad_data
					andi r16,0xf0
					ori r16,0x81	   
					out portb,r16
					cbi portb,0
					sbi portb,0
					lds r16,lcdad_data
					lsl r16
					lsl r16
					lsl r16
					lsl r16
					andi r16,0xf0
					ori r16,0x01
					out portb,r16
					cbi portb,0
					sbi portb,0
					rcall tim50us

					pop r16
					out sreg,r16
					pop r16
					ret

;----------------------------------------
;PB0-[E-6]    PB1-[RS-4]   PB2-[R/W-5]  PB3-[ ] 
;PB4-[DB4-11] PB5-[DB5-12] PB6-[DB6-13] PB7-[DB7-14]   
;
;
lcd_set:			push r16
					in r16,sreg
					push r16
					sbi portb,0				;E
					lds r16,lcdset_data
					andi r16,0xf0
					ori r16,0x03
					out portb,r16
					cbi portb,0
					sbi portb,0
					lds r16,lcdset_data
					lsl r16
					lsl r16
					lsl r16
					lsl r16
					andi r16,0xf0
					ori r16,0x03
					out portb,r16
					cbi portb,0
					sbi portb,0
					rcall tim50us
					pop r16
					out sreg,r16
					pop r16
					ret
;----------------lcd ini
;----------------------------------------
;PB0-[E-6]    PB1-[RS-4]   PB2-[R/W-5]  PB3-[ ] 
;PB4-[DB4-11] PB5-[DB5-12] PB6-[DB6-13] PB7-[DB7-14]   
;
;					
lcdini:				ldi r16,8
lcddec:				
					dec r16
					cpi r16,0
					breq lcdini_1
					rcall tim10ms
					rcall tim10ms
					rjmp lcddec
lcdini_1:			ldi r16,0x31			;0b01000011
					out portb,r16			;
					cbi portb,0
					sbi portb,0
;------------
lcdini_2:			ldi r16,8
lcddec1:			dec r16
					cpi r16,0
					breq lcdini_3
					rcall tim10ms
					rjmp lcddec1
lcdini_3:			ldi r16,0x31			;0b01000011
					out portb,r16
					cbi portb,0
					sbi portb,0
;-------------
					rcall 	tim100us		
					rcall	tim100us
					rcall tim1ms
					rcall tim1ms
					ldi r16,0x31			;0b01000011
					out portb,r16			;
					cbi portb,0
					sbi portb,0
;-------------
					rcall tim100us
					ldi r16,0x21			;0b01000010
					out portb,r16			;4bt
					cbi portb,0
					sbi portb,0
					rcall tim100us
					rcall tim1ms
;-------------
					ldi r16,0x21			;0b01000010
					out portb,r16
					cbi portb,0
					sbi portb,0
					ldi r16,0x81			;0b01001000			
					out portb,r16			;[ ][E][RS][R/W][N][F][ ][ ]
					cbi portb,0				
					sbi portb,0
					rcall tim100us
					rcall tim1ms
;---------------			
					ldi r16,0x01			;0b01000000
					out portb,r16
					cbi portb,0
					sbi portb,0
					ldi r16,0xc1			;0b01001100	;\off
					out portb,r16			;0000-01000
					cbi portb,0
					sbi portb,0
;-----------------
					rcall tim100us
					ldi r16,0x01			;0b01000000
					out portb,r16
					cbi portb,0
					sbi portb,0
					ldi r16,0x11			;0b01000001
					out portb,r16			;\NA
					cbi portb,0
					sbi portb,0
;--------------
					rcall tim100us
					rcall tim100us
					ldi r16,0x01			;0b01000000
					out portb,r16
					cbi portb,0
					sbi portb,0
					ldi r16,0x61			;0b01000110
					out portb,r16			;Gg[h
					cbi portb,0
					sbi portb,0
;-----------
					rcall tim100us
					ldi r16,0x01			;0b01000000
					out portb,r16
					cbi portb,0
					sbi portb,0
					ldi r16,0x21			;0b01000010
					out portb,r16
					cbi portb,0
					sbi portb,0
					rcall tim1ms
					rcall tim1ms
;--------------
					ret
;---------------------------------------------------------
;8MHz
;1msec^C}[̃[`Ăяo50usecɖ߂
;---------------------------------------------------------										
;  Œf[^

;---------------------------------------------------------
;4000.125=50se
;.equ	timcuntd3=0b00110101
.equ	timcuntd3=95
;call 4 rcall 3
tim50us:	 		push r16				;2	
					in r16,sreg				;1		
					push r16				;2
											;8
;					400-8=392										
					ldi r16,timcuntd3		;1										
tim50us_1:			dec r16					;1			
					cpi r16,0x00			;1	
					brne tim50us_1			;1/2
;				392-4*95=12
					nop
					nop
					nop						;9
					pop r16					;2			
					out sreg,r16			;1	
					pop r16					;2		
					ret						;4				
;---------------------------------------------------------

;--------------------------------------------------------
;				800*0.125=100us
tim100us:			push r16		
					in r16,sreg			
					push r16
											;8
;				800-8=792
					rcall tim50us			;400
;				792-400=342
					ldi r16,83				;				
											
tim100us_1:			dec r16					;1
					cpi r16,0				;1
					brne tim100Us_1			;1/2
;				342-4*83=10
					nop									
;				10-1=9
					pop r16				
					out sreg,r16		
					pop r16				
					ret	
;------------------------------------------
;				8000*.125=1000us
tim1ms:				push r16		
					in r16,sreg			
					push r16
											;8
;				8000-8=7992																					
					ldi r16,9				;1										
tim1ms_1:			dec r16					;1
					rcall tim100us			;800
					cpi r16,0				;1
					brne tim1ms_1			;1/2
;				7992-804*9=756
					rcall tim50us			;400
;				756-400=356
					ldi r16,86				;				
tim1ms_2:			dec r16					;1
					cpi r16,0				;1
					brne tim1ms_2			;1/2
;				356-4*86=12										
					nop
					nop	
					nop						;9
					pop r16				
					out sreg,r16		
					pop r16				
					ret	
;---------------------------------------
;---------------------------------------------
;				80000*0.125=10000
tim10ms:			push r16
					in r16,sreg
					push r16
											;8
;				80000-8=89992
					ldi r16,10				;1
											;
tim10ms_1:			rcall tim1ms			;8000
					dec r16					;1
					cpi r16,0				;1
					brne tim10ms_1			;1/2
;				89992-8004*11=9952
					ldi r16,12						
tim10ms_2:			rcall tim100us			;800
					dec r16					;1
					cpi r16,0				;1
					brne tim10ms_2			;1/2
;				9952-804*12=304
					ldi r16,73					
tim10ms_3:			dec r16					;1
					cpi r16,0				;1
					brne tim10ms_3			;1/2
;				304-4*73=12
					nop
					nop
					nop
					pop r16
					out sreg,r16
					pop r16
					ret		
;------------------------------
;oCiBCDɕϊ
;ő0x270F(9999)܂
;
bin2bcd:			push r16
					in r16,sreg
					push r16
					push r17
					push r18
					push r19
					push r20
					ldi r18,0
					lds r16,data_bin0
					lds r17,data_bin1
bin1000:			inc r18
					subi r16,0xe8
					sbci r17,0x03
					brcs bin100
					rjmp bin1000
bin100:				dec r18
					sts bcd_d3,r18
					ldi r19,0xe8
					ldi r20,0x03
					add r16,r19
					adc r17,r20
					ldi r18,0
bin100_1:			inc r18
					subi r16,0x64
					sbci r17,0
					brcs bin10
					rjmp bin100_1
bin10:				dec r18
					sts bcd_d2,r18
					ldi r19,0x64
					add r16,r19
					ldi r18,0
bin10_1:			inc r18
					subi r16,0x0a
					brcs bin1
					jmp bin10_1
bin1:				dec r18
					sts bcd_d1,r18
					ldi r19,0x0a
					add r16,r19
					ldi r18,0
					sts bcd_d0,r16
					pop r20
					pop r19
					pop r18		
					pop r17
					pop r16
					out sreg,r16
					pop r16
					ret

